// General-purpose Photovoltaic Device Model gpvdm.com - a drift diffusion
// base/Shockley-Read-Hall model for 1st, 2nd and 3rd generation solarcells.
// The model can simulate OLEDs, Perovskite cells, and OFETs.
// 
// Copyright (C) 2008-2020 Roderick C. I. MacKenzie
// All rights reserved.
// 
// https://www.gpvdm.com
// r.c.i.mackenzie at googlemail.com
// 
// 
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are met:
//     * Redistributions of source code must retain the above copyright
//       notice, this list of conditions and the following disclaimer.
//     * Redistributions in binary form must reproduce the above copyright
//       notice, this list of conditions and the following disclaimer in the
//       documentation and/or other materials provided with the distribution.
//     * Neither the name of the GPVDM nor the
//       names of its contributors may be used to endorse or promote products
//       derived from this software without specific prior written permission.
// 
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
// ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
// WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
// DISCLAIMED. IN NO EVENT SHALL Roderick C. I. MacKenzie BE LIABLE FOR ANY
// DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
// (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
// LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND
// ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
// (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.


#include <stdio.h>
#include <stdlib.h>
#include "sim.h"
#include <math.h>


double dB(double x)
{
double value;
   if (fabs(x)>1e-10) value=(exp(x)*(1.0-x)-1.0)/(exp(x)-1.0)/(exp(x)-1.0);
   //if (fabs(y)>1.0) value=(exp(y)*(1.0-y)-1.0)/(exp(y)-1.0)/(exp(y)-1.0);
   else value=(-0.5-x/3.0-x*x/8.0)/(1.0+x+7.0*x*x/12.0); //-0.5+1.0/6.0*y; //-1.0/180.0*y*y*y;
//   if (fabs(y)>1e-30) value=y/(exp(y)-1.0);
//   else value=1.0/(1.0+y/2.0+y*y/6.0);

/*double ret;
if (mod(x)<1e-6)
{
ret=-0.5+(1.0/6.0)*x;
}else
{
ret=exp(x)+x*exp(x)-1.0;
}
return ret;*/
return value;
}


double B(double x)
{
double ret;
if (mod(x)<1e-16)
{
ret=1-0.5*x+(1.0/12.0)*x*x;
}else
{
ret=x/(exp(x)-1.0);
}
return ret;
}

double get_I(struct device *in)
{
double ret=0.0;
ret=(in->Jn[0]+in->Jp[0])*(in->xlen*in->zlen);
return ret;
}

double mod(double x)
{
if (x<0) return -x;
return x;
}

double get_J(struct device *in)
{
double ret=0.0;
ret=(in->Jn[0]+in->Jp[0]);
return ret;
}


